OpenTTD

- Main Page
- Related Pages
- Modules
- Namespaces
- Data Structures
- Files

- Data Structures
- Class Hierarchy
- Data Fields

Public Member Functions | Private Attributes
DefaultStringIterator Class Reference

Fallback simple string iterator. More...

Inheritance diagram for DefaultStringIterator:

## Public Member Functions
virtual void | SetString (const char *s)
| Set a new iteration string.
virtual size_t | SetCurPosition (size_t pos)
| Change the current string cursor.
virtual size_t | Next (IterType what)
| Advance the cursor by one iteration unit.
virtual size_t | Prev (IterType what)
| Move the cursor back by one iteration unit.

## Private Attributes
const char * | string
| Current string.
size_t | len
| String length.
size_t | cur_pos
| Current iteration position.

## Additional Inherited Members
Public Types inherited from StringIterator
enum | IterType { ITER_CHARACTER, ITER_WORD }
| Type of the iterator. More...
Static Public Member Functions inherited from StringIterator
static StringIterator * | Create ()
| Create a new iterator instance.
Static Public Attributes inherited from StringIterator
static const size_t | END = SIZE_MAX
| Sentinel to indicate end-of-iteration.

## Detailed Description

Fallback simple string iterator.

Definition at line 747 of file string.cpp.

## Member Function Documentation

virtual size_t DefaultStringIterator::Next | ( | IterType | what | ) |
| inline virtual

Advance the cursor by one iteration unit.

Returns
  New cursor position (in bytes) or END if the cursor is already at the end of the string.

Implements StringIterator.

Definition at line 773 of file string.cpp.

References cur_pos, StringIterator::END, IsWhitespace(), StringIterator::ITER_CHARACTER, StringIterator::ITER_WORD, len, and Utf8Decode().

virtual size_t DefaultStringIterator::Prev | ( | IterType | what | ) |
| inline virtual

Move the cursor back by one iteration unit.

Returns
  New cursor position (in bytes) or END if the cursor is already at the start of the string.

Implements StringIterator.

Definition at line 811 of file string.cpp.

References cur_pos, StringIterator::END, IsWhitespace(), StringIterator::ITER_CHARACTER, StringIterator::ITER_WORD, string, Utf8Decode(), and Utf8PrevChar().

virtual size_t DefaultStringIterator::SetCurPosition | ( | size_t | pos | ) |
| inline virtual

Change the current string cursor.

Parameters

  p | New cursor position.

Returns
  Actual new cursor position at the next valid character boundary.

Precondition
  p has to be inside the current string.

Implements StringIterator.

Definition at line 765 of file string.cpp.

References cur_pos, and len.

virtual void DefaultStringIterator::SetString | ( | const char * | s | ) |
| inline virtual

Set a new iteration string.

Must also be called if the string contents changed. The cursor is reset to the start of the string.

Parameters

  s | New string.

Implements StringIterator.

Definition at line 758 of file string.cpp.

References cur_pos, and len.

The documentation for this class was generated from the following file:

- src/string.cpp